/*
    remote_ctrl Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "remote_control.h"
#include "ai.h"
#include "shoot.h"
#include "chassic.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
extern RC_ctrl_t rc_ctrl;
Gimbal_CMD_t remote_cmd;
Gimbal_IMU_t imu;
COMP_AT9S_CMD_t shoot_rc_cmd;

Chassis_CMD_t chassic_rc_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_remote_ctrl(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / REMOTE_CTRL_FREQ;

  osDelay(REMOTE_CTRL_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
	remote_control_init();
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
		remote_ParseHost(&remote_cmd,&rc_ctrl,&imu);
		remote_shoot_ParseHost(&shoot_rc_cmd,&rc_ctrl);
    osMessageQueueReset(task_runtime.msgq.gimbal.cmd);
    osMessageQueuePut(task_runtime.msgq.gimbal.cmd,&remote_cmd, 0, 0);
		osMessageQueueReset(task_runtime.msgq.shoot.shoot_cmd);
    osMessageQueuePut(task_runtime.msgq.shoot.shoot_cmd,&shoot_rc_cmd, 0, 0);
		osMessageQueueReset(task_runtime.msgq.chassic.cmd);
    osMessageQueuePut(task_runtime.msgq.chassic.cmd,&chassic_rc_cmd, 0, 0);		
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}